/* Implement the strndup function.
   Copyright 2005 Free Software Foundation, Inc.
   Written by Kaveh R. Ghazi <ghazi@caip.rutgers.edu>.
*/

/*
@deftypefn Extension char* strndup (const char *@var{s}, size_t @var{n})

Returns a pointer to a copy of @var{s} with at most @var{n} bytes
in memory obtained from @code{malloc}, or @code{NULL} if insufficient
memory was available.  The result is always NUL terminated.

@end deftypefn
*/

#include <stdlib.h>
#include <string.h>

char*strndup(const char *s, size_t n) {
  if (!s || !n) return 0;
  size_t l = strlen(s);
  if (n>l) n = l;
  char *r = new char[n+1];
  if (!r) return 0;
  r[n] = 0;
  return (char*)memcpy(r,s,n);
}
